Description

Sometimes, validation should only be executed on persist, sometimes on the controller invocation. Especially when building multi-step
forms, one needs to be able to partially validate an object and store the invalid object in the database.

I'd suggest the concept of "Validation Groups" from Symfony: http://symfony.com/doc/current/book/validation.html#validation-groups

Each Validate annotation can get one or multiple validationGroups assigned; the "Default" validation group is used if none is
specified.

When validating in the persistence layer, we use "Default" and "Persistence" as validation group; i.e. only validators which have either
Default or Persistence assigned as validationGroup get executed.

When being inside a controller invocation, the used validation groups should be configurable; using "Default", "Controller" if none is
specified.

Related issues:
related to TYPO3.Flow - Feature # 36695: Control Validation Groups and add Gr... Resolved 2012-04-28

Associated revisions
Revision 7aebd16f - 2012-04-27 14:10 - Sebastian Kurfuerst

[FEATURE] (Validation): Context-specific validation through Validation Groups

Sometimes, Validation should only be executed on Persist, or on the Controller
invocation. Especially when building multi-step forms, one needs to be able to
partially validate an object and store the invalid object in the database.

This change set implements "validation groups", i.e. each validator annotation
can have a "validation group" assigned, and when validation happens, the validators
get only executed if at least one validation group matches.

Furthermore, it adds a documentation skeleton for partial validation.

Resolves: #32832
Change-Id: I868310d3ff6352d1f9139a38d44296ec223553ee
Releases: 1.1

History
#1 - 2011-12-24 21:16 - Gerrit Code Review
- Status changed from Accepted to Under Review
http://symfony.com/doc/current/book/validation.html#validation-groups


Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7515

#2 - 2011-12-24 21:25 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7515

#3 - 2012-04-04 16:29 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7515

#4 - 2012-04-27 14:08 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7515

#5 - 2012-04-27 14:10 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7515

#6 - 2012-04-27 14:38 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:7aebd16f388f07424bb6a016be7312cc01d9feea.
